package cz.vutbr.fit.ftp;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import it.sauronsoftware.ftp4j.FTPAbortedException;
import it.sauronsoftware.ftp4j.FTPClient;
import it.sauronsoftware.ftp4j.FTPDataTransferException;
import it.sauronsoftware.ftp4j.FTPException;
import it.sauronsoftware.ftp4j.FTPIllegalReplyException;

public class ExperimentalFTPClient extends Thread {

	private final String tmpDir = System.getProperty("java.io.tmpdir");
	private final String fileName;

	public ExperimentalFTPClient(int num){
		fileName = num+"_"+System.currentTimeMillis() + ".tmp";
	}

	public void run() {
		// create file
		File file = new File(tmpDir + File.separator + fileName);
		try {
			file.createNewFile();
			FileWriter fw = new FileWriter(file);
			fw.write("This is file:" + fileName);
			for (int i = 0; i < 2000; i++) {
				fw.write(" " + i);
			}
			fw.close();
		} catch (IOException e1) {
			//e1.printStackTrace();
			return;
		}

		// ftp client
		FTPClient ftp = new FTPClient();

		// loop until some error
		try {
			while (true) {
				ftp.connect("localhost", 2021);
				ftp.login("anonymous", "123456");
				ftp.setPassive(false);
				ftp.currentDirectory();

				ftp.upload(file);
				File f = new File(tmpDir + File.separator + fileName
						+ "_download");
				ftp.download(fileName, f);
				if (f.exists())
					f.delete();
				ftp.deleteFile(fileName);
				ftp.disconnect(false);
				System.out.print(".");
			}
		} catch (IllegalStateException e) {
			//e.printStackTrace();
		} catch (IOException e) {
			//e.printStackTrace();
		} catch (FTPIllegalReplyException e) {
			//e.printStackTrace();
		} catch (FTPException e) {
			//e.printStackTrace();
		} catch (FTPDataTransferException e) {
			//e.printStackTrace();
		} catch (FTPAbortedException e) {
			//e.printStackTrace();
		}
		// clean
		if (file.exists())
			file.delete();
	}

	public static void main(String[] args) {

		int numThreads = 0;
		ExperimentalFTPClient f;
		
		if (args.length != 1) {
			System.out.println(" ExperimentalFTPClient X  (X=num_threads)");
			return;
		}
		// get info from args
		try {
			numThreads = Integer.parseInt(args[0]);
		} catch (NumberFormatException e) {
			System.err.println(" Argument must be an integer.");
			return;
		}

		
		for (int i=0;i<numThreads;i++){
			f = new ExperimentalFTPClient(i);
			f.start();
		}
		
	}
}
